import sentry_sdk
from pathlib import Path
from fastapi import FastAPI
from fastapi.routing import APIRoute
from starlette.middleware.cors import CORSMiddleware
from fastapi.staticfiles import StaticFiles
from app.api.main import api_router
from app.core.config import settings


def custom_generate_unique_id(route: APIRoute) -> str:
    return f"{route.tags[0]}-{route.name}"


if settings.SENTRY_DSN and settings.ENVIRONMENT != "local":
    sentry_sdk.init(dsn=str(settings.SENTRY_DSN), enable_tracing=True)

app = FastAPI(
    title=settings.PROJECT_NAME,
    openapi_url=f"{settings.API_V1_STR}/openapi.json",
    generate_unique_id_function=custom_generate_unique_id,
    
)
# app.mount("/static", StaticFiles(directory="static"), name="static")


current_file = Path(__file__)
current_file_dir = current_file.parent
project_root = current_file_dir.parent
project_root_absolute = project_root.resolve()
static_root_absolute = project_root_absolute / "static" 

app.mount("/static", static_root_absolute, name="static")

# Set all CORS enabled origins
if settings.BACKEND_CORS_ORIGINS:
    app.add_middleware(
        CORSMiddleware,
        allow_origins=[
            str(origin).strip("/") for origin in settings.BACKEND_CORS_ORIGINS
        ] + ["http://localhost:3000"]+["http://localhost:5173"]+["http://localhost:5173/aboutUs"]+["https://cms.oneandallmusic.net"]+["https://oneandallmusic.net"],
        allow_credentials=True,
        allow_methods=["*"],
        allow_headers=["*"],
        
    )

app.include_router(api_router, prefix=settings.API_V1_STR)
